'
'  rstest.bas
'
'  test program for the rserver remote binary file server
'  Requires pb-dll 6 to compile
'
#Compile Exe
#Dim All
#Include "rsclient.inc"

#if not %def(%True)
%True = -1
%False = 0
#endif

Function PbMain

   Dim iRet As Long
   Dim hSocket As Long
   Dim hFile As Long
   Dim sReturn As String

   '- Attemp to connect
   If rsConnect(hSocket, %DEFAULT_PORT, "") = %False Then
      MsgBox "Unablet to connect to rserver on this machine."
   Else

      '- Attempt to open a remote file
      hFile = rsOpen(hSocket, "test.dat")
      If hFile < 0 Then
         MsgBox "Unable to open binary file test.dat. DOS error =" + Str$(Abs(hFile))
      Else

         '- Get the length of the remote file
         iRet = rsLof(hSocket, hFile)
         If iRet < 0 Then
            MsgBox "Unable to determine file length. DOS error =" + Str$(Abs(iRet))
         Else

            '- Write some data to the file
            MsgBox "Length of file is:" + Str$(iRet)
            rsSeek hSocket, hFile, iRet + 1
            rsPut hSocket, hFile, "This is a test"
            iRet = rsLof(hSocket, hFile)
            If iRet < 0 Then
               MsgBox "New Length of file can't be determined. DOS error =" + Str$(Abs(iRet))
            Else
               MsgBox "New Length of file is:" + Str$(iRet)
            End If

            '- Read some data from the file
            If iRet => 14 Then
               rsSeek hSocket, hFile, 1
               iRet = rsGet(hSocket, hFile, 14, sReturn)
               If iRet = 0 Then
                  MsgBox "The first 14 bytes of the file are:" + $cr + sReturn
               Else
                  MsgBox "Error reading file. DOS error =" + Str$(iRet)
               end if
            End If
         End If

         '- Close File
         rsClose hSocket, hFile
      End If

      '- Terminate Connection
      rsDisconnect hSocket
   End If

   MsgBox "Remote File Demo Complete."

End Function

